(* Dfinition des principaux types *)

type ident = string;;

type baseexpr =
    Var of ident
  | Cte of int;;

type expr =
    Base of baseexpr
  | New of baseexpr * ident
  | Adress of ident
  | Content of ident
  | Plus  of baseexpr * baseexpr
  | Mul   of baseexpr * baseexpr
  | Div   of baseexpr * baseexpr
  | Minus of baseexpr * baseexpr
  | Equal   of baseexpr * baseexpr
  | Diff    of baseexpr * baseexpr
  | Less    of baseexpr * baseexpr
  | Greater of baseexpr * baseexpr;;

type location =
    Variable of ident
  | Deref of ident;;

type instr =
    Affect of location * expr
  | If of expr * instr * instr
  | While of expr * instr
  | Sequence of instr * instr
  | SSkip;;
