(* Diverses fonctions utilitaires *)

let new_num = let compt = ref 0 in
 fun () -> incr compt; !compt;;

let (var : int -> ident) = fun n -> "_new" ^ (string_of_int n);;
let (vark : int -> ident) = fun n -> "_newk" ^ (string_of_int n);;

let (is_k : ident -> bool) = fun x -> String.get x 0 = '_' && 
                                      String.get x 4 = 'k';;

let rec merge l1 l2 = match (l1,l2) with
   (x::xs,y::ys) -> if x = y then x::merge xs ys
                    else if x < y then x::merge xs (y::ys)
                    else y::merge (x::xs) ys
 | ([],l) -> l
 | (l,[]) -> l;;

let rec filter p = function
   (x::xs) -> if p x then x::filter p xs else filter p xs
 | [] -> [];;

let varsetbaseexpr = function
   Var(var) -> singleton var
 | Cte(_) -> empty_set;;

let rec varsetexpr = function
   Base(e) -> varsetbaseexpr e
 | Adress(var) -> singleton var
 | Content(var) -> singleton var
 | New(e,x) -> add_to_set x (varsetbaseexpr e)
 | Plus(e1,e2) -> union (varsetbaseexpr e1) (varsetbaseexpr e2)
 | Mul(e1,e2) -> union (varsetbaseexpr e1) (varsetbaseexpr e2)
 | Div(e1,e2) -> union (varsetbaseexpr e1) (varsetbaseexpr e2)
 | Minus(e1,e2) -> union (varsetbaseexpr e1) (varsetbaseexpr e2)
 | Equal(e1,e2) -> union (varsetbaseexpr e1) (varsetbaseexpr e2)
 | Diff(e1,e2) -> union (varsetbaseexpr e1) (varsetbaseexpr e2)
 | Less(e1,e2) -> union (varsetbaseexpr e1) (varsetbaseexpr e2)
 | Greater(e1,e2) -> union (varsetbaseexpr e1) (varsetbaseexpr e2);;

let rec varset = function
   Affect(Variable(var),e) -> union (singleton var) (varsetexpr e)
 | Affect(Deref(var),e) -> union (singleton var) (varsetexpr e)
 | If(e,i1,i2) -> union (varsetexpr e) (union (varset i1) (varset i2))
 | While(e,i) -> union (varsetexpr e) (varset i)
 | Sequence(i1,i2) -> union (varset i1) (varset i2)
 | SSkip -> empty_set;;

let list n =
 let l = ref [] in
 for i = n - 1 downto 0 do l := i :: (!l) done;
 !l;;

let copy_expr = function
   New(e,_) -> New(e,var (new_num ()))
 | x -> x;;

let rec copy_instr = function
   Affect(x,e) -> Affect(x,copy_expr e)
 | SSkip -> SSkip
 | If(e,i1,i2) -> If(e,copy_instr i1,copy_instr i2)
 | While(e,i) -> While(e,copy_instr i)
 | Sequence(i1,i2) -> Sequence(copy_instr i1,copy_instr i2);;
